commit a23bdb4bb3ee84d5926f0ed3570dd523abc8d6d9
Author: Ken Gaillot <kgaillot@redhat.com>
Date:   Thu Aug 24 18:21:09 2017 -0500

    Test: pengine: new regression test for migration behind remote migration
    
    This currently produces an invalid transition.

Index: pacemaker/pengine/regression.sh
===================================================================
--- pacemaker.orig/pengine/regression.sh
+++ pacemaker/pengine/regression.sh
@@ -299,6 +299,7 @@ do_test bug-1820-1 "Non-migration in a g
 do_test migrate-5 "Primitive migration with a clone"
 do_test migrate-fencing "Migration after Fencing"
 do_test migrate-both-vms "Migrate two VMs that have no colocation"
+do_test migration-behind-migrating-remote "Migrate resource behind migrating remote connection"
 
 do_test 1-a-then-bm-move-b "Advanced migrate logic. A then B. migrate B."
 do_test 2-am-then-b-move-a "Advanced migrate logic, A then B, migrate A without stopping B"
Index: pacemaker/pengine/test10/migration-behind-migrating-remote.dot
===================================================================
--- /dev/null
+++ pacemaker/pengine/test10/migration-behind-migrating-remote.dot
@@ -0,0 +1,28 @@
+digraph "g" {
+"all_stopped" [ style=bold color="green" fontcolor="orange"]
+"remote1_migrate_from_0 node2" -> "remote1_start_0 node2" [ style = bold]
+"remote1_migrate_from_0 node2" -> "remote1_stop_0 node1" [ style = bold]
+"remote1_migrate_from_0 node2" [ style=bold color="green" fontcolor="black"]
+"remote1_migrate_to_0 node1" -> "remote1_migrate_from_0 node2" [ style = bold]
+"remote1_migrate_to_0 node1" [ style=bold color="green" fontcolor="black"]
+"remote1_monitor_60000 node2" [ style=bold color="green" fontcolor="black"]
+"remote1_start_0 node2" -> "remote1_monitor_60000 node2" [ style = bold]
+"remote1_start_0 node2" -> "rsc1_migrate_to_0 remote1" [ style = bold]
+"remote1_start_0 node2" [ style=bold color="green" fontcolor="orange"]
+"remote1_stop_0 node1" -> "all_stopped" [ style = bold]
+"remote1_stop_0 node1" -> "remote1_start_0 node2" [ style = bold]
+"remote1_stop_0 node1" [ style=bold color="green" fontcolor="black"]
+"rsc1_migrate_from_0 remote2" -> "rsc1_start_0 remote2" [ style = bold]
+"rsc1_migrate_from_0 remote2" -> "rsc1_stop_0 remote1" [ style = bold]
+"rsc1_migrate_from_0 remote2" [ style=bold color="green" fontcolor="black"]
+"rsc1_migrate_to_0 remote1" -> "rsc1_migrate_from_0 remote2" [ style = bold]
+"rsc1_migrate_to_0 remote1" [ style=bold color="green" fontcolor="black"]
+"rsc1_monitor_10000 remote2" [ style=bold color="green" fontcolor="black"]
+"rsc1_start_0 remote2" -> "rsc1_monitor_10000 remote2" [ style = bold]
+"rsc1_start_0 remote2" [ style=bold color="green" fontcolor="orange"]
+"rsc1_stop_0 remote1" -> "all_stopped" [ style = bold]
+"rsc1_stop_0 remote1" -> "remote1_migrate_to_0 node1" [ style = dashed]
+"rsc1_stop_0 remote1" -> "remote1_stop_0 node1" [ style = bold]
+"rsc1_stop_0 remote1" -> "rsc1_start_0 remote2" [ style = bold]
+"rsc1_stop_0 remote1" [ style=bold color="green" fontcolor="black"]
+}
Index: pacemaker/pengine/test10/migration-behind-migrating-remote.exp
===================================================================
--- /dev/null
+++ pacemaker/pengine/test10/migration-behind-migrating-remote.exp
@@ -0,0 +1,150 @@
+<transition_graph cluster-delay="60s" stonith-timeout="60s" failed-stop-offset="INFINITY" failed-start-offset="INFINITY"  transition_id="0">
+  <synapse id="0">
+    <action_set>
+      <rsc_op id="12" operation="migrate_from" operation_key="rsc1_migrate_from_0" on_node="remote2" on_node_uuid="remote2" router_node="node2">
+        <primitive id="rsc1" class="ocf" provider="pacemaker" type="Dummy"/>
+        <attributes CRM_meta_migrate_source="remote1" CRM_meta_migrate_target="remote2" CRM_meta_on_node="remote2" CRM_meta_on_node_uuid="remote2" CRM_meta_timeout="20000" />
+      </rsc_op>
+    </action_set>
+    <inputs>
+      <trigger>
+        <rsc_op id="11" operation="migrate_to" operation_key="rsc1_migrate_to_0" on_node="remote1" on_node_uuid="remote1" router_node="node1"/>
+      </trigger>
+    </inputs>
+  </synapse>
+  <synapse id="1">
+    <action_set>
+      <rsc_op id="11" operation="migrate_to" operation_key="rsc1_migrate_to_0" on_node="remote1" on_node_uuid="remote1" router_node="node1">
+        <primitive id="rsc1" class="ocf" provider="pacemaker" type="Dummy"/>
+        <attributes CRM_meta_migrate_source="remote1" CRM_meta_migrate_target="remote2" CRM_meta_on_node="remote1" CRM_meta_on_node_uuid="remote1" CRM_meta_record_pending="true" CRM_meta_timeout="20000" />
+      </rsc_op>
+    </action_set>
+    <inputs>
+      <trigger>
+        <pseudo_event id="14" operation="start" operation_key="remote1_start_0"/>
+      </trigger>
+    </inputs>
+  </synapse>
+  <synapse id="2">
+    <action_set>
+      <rsc_op id="10" operation="monitor" operation_key="rsc1_monitor_10000" on_node="remote2" on_node_uuid="remote2" router_node="node2">
+        <primitive id="rsc1" class="ocf" provider="pacemaker" type="Dummy"/>
+        <attributes CRM_meta_interval="10000" CRM_meta_name="monitor" CRM_meta_on_node="remote2" CRM_meta_on_node_uuid="remote2" CRM_meta_timeout="20000" />
+      </rsc_op>
+    </action_set>
+    <inputs>
+      <trigger>
+        <pseudo_event id="9" operation="start" operation_key="rsc1_start_0"/>
+      </trigger>
+    </inputs>
+  </synapse>
+  <synapse id="3">
+    <action_set>
+      <pseudo_event id="9" operation="start" operation_key="rsc1_start_0">
+        <attributes CRM_meta_timeout="20000" />
+      </pseudo_event>
+    </action_set>
+    <inputs>
+      <trigger>
+        <rsc_op id="8" operation="stop" operation_key="rsc1_stop_0" on_node="remote1" on_node_uuid="remote1" router_node="node1"/>
+      </trigger>
+      <trigger>
+        <rsc_op id="12" operation="migrate_from" operation_key="rsc1_migrate_from_0" on_node="remote2" on_node_uuid="remote2" router_node="node2"/>
+      </trigger>
+    </inputs>
+  </synapse>
+  <synapse id="4">
+    <action_set>
+      <rsc_op id="8" operation="stop" operation_key="rsc1_stop_0" on_node="remote1" on_node_uuid="remote1" router_node="node1">
+        <primitive id="rsc1" class="ocf" provider="pacemaker" type="Dummy"/>
+        <attributes CRM_meta_on_node="remote1" CRM_meta_on_node_uuid="remote1" CRM_meta_timeout="20000" />
+      </rsc_op>
+    </action_set>
+    <inputs>
+      <trigger>
+        <rsc_op id="12" operation="migrate_from" operation_key="rsc1_migrate_from_0" on_node="remote2" on_node_uuid="remote2" router_node="node2"/>
+      </trigger>
+    </inputs>
+  </synapse>
+  <synapse id="5">
+    <action_set>
+      <rsc_op id="17" operation="migrate_from" operation_key="remote1_migrate_from_0" on_node="node2" on_node_uuid="2">
+        <primitive id="remote1" class="ocf" provider="pacemaker" type="remote"/>
+        <attributes CRM_meta_migrate_source="node1" CRM_meta_migrate_target="node2" CRM_meta_on_node="node2" CRM_meta_on_node_uuid="2" CRM_meta_timeout="20000" />
+      </rsc_op>
+    </action_set>
+    <inputs>
+      <trigger>
+        <rsc_op id="16" operation="migrate_to" operation_key="remote1_migrate_to_0" on_node="node1" on_node_uuid="1"/>
+      </trigger>
+    </inputs>
+  </synapse>
+  <synapse id="6">
+    <action_set>
+      <rsc_op id="16" operation="migrate_to" operation_key="remote1_migrate_to_0" on_node="node1" on_node_uuid="1">
+        <primitive id="remote1" class="ocf" provider="pacemaker" type="remote"/>
+        <attributes CRM_meta_migrate_source="node1" CRM_meta_migrate_target="node2" CRM_meta_on_node="node1" CRM_meta_on_node_uuid="1" CRM_meta_timeout="20000" />
+      </rsc_op>
+    </action_set>
+    <inputs/>
+  </synapse>
+  <synapse id="7">
+    <action_set>
+      <rsc_op id="15" operation="monitor" operation_key="remote1_monitor_60000" on_node="node2" on_node_uuid="2">
+        <primitive id="remote1" class="ocf" provider="pacemaker" type="remote"/>
+        <attributes CRM_meta_interval="60000" CRM_meta_name="monitor" CRM_meta_on_node="node2" CRM_meta_on_node_uuid="2" CRM_meta_timeout="20000" />
+      </rsc_op>
+    </action_set>
+    <inputs>
+      <trigger>
+        <pseudo_event id="14" operation="start" operation_key="remote1_start_0"/>
+      </trigger>
+    </inputs>
+  </synapse>
+  <synapse id="8">
+    <action_set>
+      <pseudo_event id="14" operation="start" operation_key="remote1_start_0">
+        <attributes CRM_meta_timeout="20000" />
+      </pseudo_event>
+    </action_set>
+    <inputs>
+      <trigger>
+        <rsc_op id="13" operation="stop" operation_key="remote1_stop_0" on_node="node1" on_node_uuid="1"/>
+      </trigger>
+      <trigger>
+        <rsc_op id="17" operation="migrate_from" operation_key="remote1_migrate_from_0" on_node="node2" on_node_uuid="2"/>
+      </trigger>
+    </inputs>
+  </synapse>
+  <synapse id="9">
+    <action_set>
+      <rsc_op id="13" operation="stop" operation_key="remote1_stop_0" on_node="node1" on_node_uuid="1">
+        <primitive id="remote1" class="ocf" provider="pacemaker" type="remote"/>
+        <attributes CRM_meta_on_node="node1" CRM_meta_on_node_uuid="1" CRM_meta_timeout="20000" />
+      </rsc_op>
+    </action_set>
+    <inputs>
+      <trigger>
+        <rsc_op id="8" operation="stop" operation_key="rsc1_stop_0" on_node="remote1" on_node_uuid="remote1" router_node="node1"/>
+      </trigger>
+      <trigger>
+        <rsc_op id="17" operation="migrate_from" operation_key="remote1_migrate_from_0" on_node="node2" on_node_uuid="2"/>
+      </trigger>
+    </inputs>
+  </synapse>
+  <synapse id="10">
+    <action_set>
+      <pseudo_event id="5" operation="all_stopped" operation_key="all_stopped">
+        <attributes />
+      </pseudo_event>
+    </action_set>
+    <inputs>
+      <trigger>
+        <rsc_op id="8" operation="stop" operation_key="rsc1_stop_0" on_node="remote1" on_node_uuid="remote1" router_node="node1"/>
+      </trigger>
+      <trigger>
+        <rsc_op id="13" operation="stop" operation_key="remote1_stop_0" on_node="node1" on_node_uuid="1"/>
+      </trigger>
+    </inputs>
+  </synapse>
+</transition_graph>
Index: pacemaker/pengine/test10/migration-behind-migrating-remote.scores
===================================================================
--- /dev/null
+++ pacemaker/pengine/test10/migration-behind-migrating-remote.scores
@@ -0,0 +1,20 @@
+Allocation scores:
+An invalid transition was produced
+Transition failed: terminated
+Using the original execution date of: 2017-08-21 17:12:54Z
+native_color: Fencing allocation score on node1: 0
+native_color: Fencing allocation score on node2: INFINITY
+native_color: Fencing allocation score on remote1: -INFINITY
+native_color: Fencing allocation score on remote2: -INFINITY
+native_color: remote1 allocation score on node1: 0
+native_color: remote1 allocation score on node2: INFINITY
+native_color: remote1 allocation score on remote1: -INFINITY
+native_color: remote1 allocation score on remote2: -INFINITY
+native_color: remote2 allocation score on node1: 0
+native_color: remote2 allocation score on node2: INFINITY
+native_color: remote2 allocation score on remote1: -INFINITY
+native_color: remote2 allocation score on remote2: -INFINITY
+native_color: rsc1 allocation score on node1: -INFINITY
+native_color: rsc1 allocation score on node2: -INFINITY
+native_color: rsc1 allocation score on remote1: 1
+native_color: rsc1 allocation score on remote2: INFINITY
Index: pacemaker/pengine/test10/migration-behind-migrating-remote.summary
===================================================================
--- /dev/null
+++ pacemaker/pengine/test10/migration-behind-migrating-remote.summary
@@ -0,0 +1,31 @@
+Using the original execution date of: 2017-08-21 17:12:54Z
+
+Current cluster status:
+Online: [ node1 node2 ]
+RemoteOnline: [ remote1 remote2 ]
+
+ Fencing	(stonith:fence_xvm):	Started node2
+ rsc1	(ocf::pacemaker:Dummy):	Started remote1
+ remote1	(ocf::pacemaker:remote):	Started node1
+ remote2	(ocf::pacemaker:remote):	Started node2
+
+Transition Summary:
+ * Migrate rsc1	(Started remote1 -> remote2)
+ * Migrate remote1	(Started node1 -> node2)
+
+Executing cluster transition:
+ * Resource action: remote1         migrate_to on node1
+ * Resource action: remote1         migrate_from on node2
+Transition failed: terminated
+An invalid transition was produced
+Using the original execution date of: 2017-08-21 17:12:54Z
+
+Revised cluster status:
+Online: [ node1 node2 ]
+RemoteOnline: [ remote1 remote2 ]
+
+ Fencing	(stonith:fence_xvm):	Started node2
+ rsc1	(ocf::pacemaker:Dummy):	Started remote1
+ remote1	(ocf::pacemaker:remote):	Started node2
+ remote2	(ocf::pacemaker:remote):	Started node2
+
Index: pacemaker/pengine/test10/migration-behind-migrating-remote.xml
===================================================================
--- /dev/null
+++ pacemaker/pengine/test10/migration-behind-migrating-remote.xml
@@ -0,0 +1,125 @@
+<cib crm_feature_set="3.0.10" validate-with="pacemaker-2.5" epoch="49" num_updates="13" admin_epoch="0" cib-last-written="Mon Aug 21 12:12:00 2017" update-origin="node1" update-client="crm_resource" update-user="remote1" have-quorum="1" dc-uuid="2" execution-date="1503335574">
+  <configuration>
+    <crm_config>
+      <cluster_property_set id="cib-bootstrap-options">
+        <nvpair id="cts-expected-quorum-votes" name="expected-quorum-votes" value="2"/>
+        <nvpair id="cib-bootstrap-options-have-watchdog" name="have-watchdog" value="false"/>
+        <nvpair id="cib-bootstrap-options-dc-version" name="dc-version" value="1.1.17-553.368fb3e.git.el7.centos-368fb3e"/>
+        <nvpair id="cib-bootstrap-options-cluster-infrastructure" name="cluster-infrastructure" value="corosync"/>
+      </cluster_property_set>
+    </crm_config>
+    <nodes>
+      <node id="1" uname="node1"/>
+      <node id="2" uname="node2"/>
+    </nodes>
+    <resources>
+      <primitive id="Fencing" class="stonith" type="fence_xvm">
+        <meta_attributes id="Fencing-meta">
+        </meta_attributes>
+        <instance_attributes id="Fencing-params">
+          <nvpair id="Fencing-multicast_address" name="multicast_address" value="239.255.100.100"/>
+          <nvpair id="Fencing-pcmk_host_list" name="pcmk_host_list" value="node1 node2 remote-1 remote-2"/>
+        </instance_attributes>
+        <operations>
+          <op id="Fencing-monitor-120s" interval="120s" name="monitor" timeout="120s"/>
+          <op id="Fencing-stop-0" interval="0" name="stop" timeout="60s"/>
+          <op id="Fencing-start-0" interval="0" name="start" timeout="60s"/>
+        </operations>
+      </primitive>
+      <primitive id="rsc1" class="ocf" type="Dummy" provider="pacemaker">
+        <meta_attributes id="rsc1-meta">
+          <nvpair id="rsc1-allow-migrate" name="allow-migrate" value="1"/>
+          <nvpair id="rsc1-resource-stickiness" name="resource-stickiness" value="1"/>
+        </meta_attributes>
+        <instance_attributes id="rsc1-params">
+        </instance_attributes>
+        <operations>
+          <op id="rsc1-monitor-P10S" interval="P10S" name="monitor"/>
+        </operations>
+      </primitive>
+      <primitive class="ocf" id="remote1" provider="pacemaker" type="remote">
+        <instance_attributes id="remote1-instance_attributes">
+        </instance_attributes>
+        <operations>
+          <op id="remote1-monitor-interval-60s" interval="60s" name="monitor"/>
+        </operations>
+      </primitive>
+      <primitive class="ocf" id="remote2" provider="pacemaker" type="remote">
+        <instance_attributes id="remote2-instance_attributes">
+        </instance_attributes>
+        <operations>
+          <op id="remote2-monitor-interval-60s" interval="60s" name="monitor"/>
+        </operations>
+      </primitive>
+    </resources>
+    <constraints>
+      <rsc_location id="rsc1-off-node1" rsc="rsc1" node="node1" score="-INFINITY"/>
+      <rsc_location id="rsc1-off-node2" rsc="rsc1" node="node2" score="-INFINITY"/>
+      <rsc_location id="remote1-to-node2" rsc="remote1" node="node2" score="INFINITY"/>
+      <rsc_location id="remote2-to-node2" rsc="remote2" node="node2" score="INFINITY"/>
+      <rsc_location id="Fencing-to-node2" rsc="Fencing" node="node2" score="INFINITY"/>
+      <rsc_location id="rsc1-to-remote2" rsc="rsc1" node="remote2" score="INFINITY"/>
+    </constraints>
+  </configuration>
+  <status>
+    <node_state id="1" uname="node1" in_ccm="true" crmd="online" crm-debug-origin="do_update_resource" join="member" expected="member">
+      <lrm id="1">
+        <lrm_resources>
+          <lrm_resource id="Fencing" type="fence_xvm" class="stonith">
+            <lrm_rsc_op id="Fencing_last_0" operation_key="Fencing_stop_0" operation="stop" crm-debug-origin="do_update_resource" crm_feature_set="3.0.14" transition-key="37:22:0:231989e8-bacb-4b30-ad73-d034cf9fd2ed" transition-magic="0:0;37:22:0:231989e8-bacb-4b30-ad73-d034cf9fd2ed" on_node="node1" call-id="192" rc-code="0" op-status="0" interval="0" last-run="1503335492" last-rc-change="1503335492" exec-time="12" queue-time="0" op-digest="2409d7001df14f35973634911d9875b1" ra-version="0.1"/>
+            <lrm_rsc_op id="Fencing_monitor_120000" operation_key="Fencing_monitor_120000" operation="monitor" crm-debug-origin="do_update_resource" crm_feature_set="3.0.14" transition-key="25:20:0:231989e8-bacb-4b30-ad73-d034cf9fd2ed" transition-magic="0:0;25:20:0:231989e8-bacb-4b30-ad73-d034cf9fd2ed" on_node="node1" call-id="188" rc-code="0" op-status="0" interval="120000" last-rc-change="1503335472" exec-time="5" queue-time="0" op-digest="87e7768825db29d87bc1f2119ebffe0e" ra-version="0.1"/>
+          </lrm_resource>
+          <lrm_resource id="rsc1" type="Dummy" class="ocf" provider="pacemaker">
+            <lrm_rsc_op id="rsc1_last_0" operation_key="rsc1_monitor_0" operation="monitor" crm-debug-origin="build_active_RAs" crm_feature_set="3.0.14" transition-key="28:16:7:a4c95233-ef19-40fd-89f0-0a7ce1f787a6" transition-magic="0:7;28:16:7:a4c95233-ef19-40fd-89f0-0a7ce1f787a6" on_node="node1" call-id="33" rc-code="7" op-status="0" interval="0" last-run="1503335084" last-rc-change="1503335084" exec-time="54" queue-time="0" op-digest="5de129d7fe42dbcfe537f2c63b1921b6" ra-version="1.0" op-force-restart=" fail_start_on  fake " op-restart-digest="f2317cad3d54cec5d7d7aa7d0bf35cf8" op-secure-params=" passwd " op-secure-digest="5de129d7fe42dbcfe537f2c63b1921b6"/>
+          </lrm_resource>
+          <lrm_resource id="remote1" type="remote" class="ocf" provider="pacemaker">
+            <lrm_rsc_op id="remote1_last_0" operation_key="remote1_start_0" operation="start" crm-debug-origin="build_active_RAs" crm_feature_set="3.0.14" transition-key="6:29:0:231989e8-bacb-4b30-ad73-d034cf9fd2ed" transition-magic="0:0;6:29:0:231989e8-bacb-4b30-ad73-d034cf9fd2ed" on_node="node1" call-id="18" rc-code="0" op-status="0" interval="0" last-run="1503335525" last-rc-change="1503335525" exec-time="0" queue-time="0" op-digest="f2317cad3d54cec5d7d7aa7d0bf35cf8" ra-version="0.1" op-force-restart=" reconnect_interval  port " op-restart-digest="f2317cad3d54cec5d7d7aa7d0bf35cf8"/>
+            <lrm_rsc_op id="remote1_monitor_60000" operation_key="remote1_monitor_60000" operation="monitor" crm-debug-origin="do_update_resource" crm_feature_set="3.0.14" transition-key="19:-1:0:xxxxxxxx-xxxx-xxxx-xxxx-xxxxxxxxxxxx" transition-magic="0:0;19:-1:0:xxxxxxxx-xxxx-xxxx-xxxx-xxxxxxxxxxxx" on_node="node1" call-id="19" rc-code="0" op-status="0" interval="60000" last-rc-change="1503335516" exec-time="0" queue-time="0" op-digest="4811cef7f7f94e3a35a70be7916cb2fd" ra-version="0.1"/>
+          </lrm_resource>
+          <lrm_resource id="remote2" type="remote" class="ocf" provider="pacemaker">
+            <lrm_rsc_op id="remote2_last_0" operation_key="remote2_monitor_0" operation="monitor" crm-debug-origin="build_active_RAs" crm_feature_set="3.0.14" transition-key="6:29:0:231989e8-bacb-4b30-ad73-d034cf9fd2ed" transition-magic="0:0;6:29:0:231989e8-bacb-4b30-ad73-d034cf9fd2ed" on_node="node1" call-id="18" rc-code="7" op-status="0" interval="0" last-run="1503335525" last-rc-change="1503335525" exec-time="0" queue-time="0" op-digest="261b4fde9eb7965580f152a20c775486" ra-version="0.1" op-force-restart=" reconnect_interval  port " op-restart-digest="1dbaa1569a09b2a43b8d2b8037a48749"/>
+          </lrm_resource>
+        </lrm_resources>
+      </lrm>
+    </node_state>
+    <node_state id="2" uname="node2" crmd="online" crm-debug-origin="do_update_resource" in_ccm="true" join="member" expected="member">
+      <lrm id="2">
+        <lrm_resources>
+          <lrm_resource id="Fencing" type="fence_xvm" class="stonith">
+            <lrm_rsc_op id="Fencing_last_0" operation_key="Fencing_start_0" operation="start" crm-debug-origin="do_update_resource" crm_feature_set="3.0.14" transition-key="38:22:0:231989e8-bacb-4b30-ad73-d034cf9fd2ed" transition-magic="0:0;38:22:0:231989e8-bacb-4b30-ad73-d034cf9fd2ed" on_node="node2" call-id="179" rc-code="0" op-status="0" interval="0" last-run="1503335492" last-rc-change="1503335492" exec-time="34" queue-time="0" op-digest="9a843e3af459b23b342161743e5da19c" ra-version="0.1"/>
+            <lrm_rsc_op id="Fencing_monitor_120000" operation_key="Fencing_monitor_120000" operation="monitor" crm-debug-origin="do_update_resource" crm_feature_set="3.0.14" transition-key="39:22:0:231989e8-bacb-4b30-ad73-d034cf9fd2ed" transition-magic="0:0;39:22:0:231989e8-bacb-4b30-ad73-d034cf9fd2ed" on_node="node2" call-id="181" rc-code="0" op-status="0" interval="120000" last-rc-change="1503335492" exec-time="15" queue-time="0" op-digest="f17c939f5d0147b0772fb047e175cb1f" ra-version="0.1"/>
+          </lrm_resource>
+          <lrm_resource id="rsc1" type="Dummy" class="ocf" provider="pacemaker">
+            <lrm_rsc_op id="rsc1_last_0" operation_key="rsc1_monitor_0" operation="monitor" crm-debug-origin="build_active_RAs" crm_feature_set="3.0.14" transition-key="9:1:7:2dc02a24-b145-46ac-ba2d-ee462fdab7ab" transition-magic="0:7;9:1:7:2dc02a24-b145-46ac-ba2d-ee462fdab7ab" on_node="node2" call-id="39" rc-code="7" op-status="0" interval="0" last-run="1503334850" last-rc-change="1503334850" exec-time="11" queue-time="0" op-digest="f2317cad3d54cec5d7d7aa7d0bf35cf8" ra-version="1.0" op-force-restart=" fail_start_on  fake " op-restart-digest="f2317cad3d54cec5d7d7aa7d0bf35cf8" op-secure-params=" passwd " op-secure-digest="5de129d7fe42dbcfe537f2c63b1921b6"/>
+          </lrm_resource>
+          <lrm_resource id="remote1" type="remote" class="ocf" provider="pacemaker">
+            <lrm_rsc_op id="remote1_last_0" operation_key="remote1_monitor_0" operation="monitor" crm-debug-origin="build_active_RAs" crm_feature_set="3.0.14" transition-key="6:29:0:231989e8-bacb-4b30-ad73-d034cf9fd2ed" transition-magic="0:0;6:29:0:231989e8-bacb-4b30-ad73-d034cf9fd2ed" on_node="node2" call-id="18" rc-code="7" op-status="0" interval="0" last-run="1503335525" last-rc-change="1503335525" exec-time="0" queue-time="0" op-digest="261b4fde9eb7965580f152a20c775486" ra-version="0.1" op-force-restart=" reconnect_interval  port " op-restart-digest="1dbaa1569a09b2a43b8d2b8037a48749"/>
+          </lrm_resource>
+          <lrm_resource id="remote2" type="remote" class="ocf" provider="pacemaker">
+            <lrm_rsc_op id="remote2_last_0" operation_key="remote2_start_0" operation="start" crm-debug-origin="build_active_RAs" crm_feature_set="3.0.14" transition-key="6:29:0:231989e8-bacb-4b30-ad73-d034cf9fd2ed" transition-magic="0:0;6:29:0:231989e8-bacb-4b30-ad73-d034cf9fd2ed" on_node="node2" call-id="18" rc-code="0" op-status="0" interval="0" last-run="1503335525" last-rc-change="1503335525" exec-time="0" queue-time="0" op-digest="f2317cad3d54cec5d7d7aa7d0bf35cf8" ra-version="0.1" op-force-restart=" reconnect_interval  port " op-restart-digest="f2317cad3d54cec5d7d7aa7d0bf35cf8"/>
+            <lrm_rsc_op id="remote2_monitor_60000" operation_key="remote2_monitor_60000" operation="monitor" crm-debug-origin="do_update_resource" crm_feature_set="3.0.14" transition-key="19:-1:0:xxxxxxxx-xxxx-xxxx-xxxx-xxxxxxxxxxxx" transition-magic="0:0;19:-1:0:xxxxxxxx-xxxx-xxxx-xxxx-xxxxxxxxxxxx" on_node="node1" call-id="19" rc-code="0" op-status="0" interval="60000" last-rc-change="1503335516" exec-time="0" queue-time="0" op-digest="4811cef7f7f94e3a35a70be7916cb2fd" ra-version="0.1"/>
+          </lrm_resource>
+        </lrm_resources>
+      </lrm>
+    </node_state>
+    <node_state remote_node="true" id="remote1" uname="remote1" in_ccm="false" crm-debug-origin="post_cache_update">
+      <lrm id="remote1">
+        <lrm_resources>
+          <lrm_resource id="rsc1" type="Dummy" class="ocf" provider="pacemaker">
+            <lrm_rsc_op id="rsc1_last_0" operation_key="rsc1_start_0" operation="start" crm-debug-origin="build_active_RAs" crm_feature_set="3.0.14" transition-key="6:29:0:231989e8-bacb-4b30-ad73-d034cf9fd2ed" transition-magic="0:0;6:29:0:231989e8-bacb-4b30-ad73-d034cf9fd2ed" on_node="remote1" call-id="18" rc-code="0" op-status="0" interval="0" last-run="1503335525" last-rc-change="1503335525" exec-time="0" queue-time="0" op-digest="f2317cad3d54cec5d7d7aa7d0bf35cf8" ra-version="0.1" op-force-restart=" reconnect_interval  port " op-restart-digest="f2317cad3d54cec5d7d7aa7d0bf35cf8"/>
+            <lrm_rsc_op id="rsc1_monitor_10000" operation_key="rsc1_monitor_10000" operation="monitor" crm-debug-origin="do_update_resource" crm_feature_set="3.0.14" transition-key="19:-1:0:xxxxxxxx-xxxx-xxxx-xxxx-xxxxxxxxxxxx" transition-magic="0:0;19:-1:0:xxxxxxxx-xxxx-xxxx-xxxx-xxxxxxxxxxxx" on_node="remote1" call-id="19" rc-code="0" op-status="0" interval="10000" last-rc-change="1503335516" exec-time="0" queue-time="0" op-digest="4811cef7f7f94e3a35a70be7916cb2fd" ra-version="0.1"/>
+          </lrm_resource>
+        </lrm_resources>
+      </lrm>
+    </node_state>
+    <node_state remote_node="true" id="remote2" uname="remote2" in_ccm="false" crm-debug-origin="post_cache_update">
+      <lrm id="remote2">
+        <lrm_resources>
+          <lrm_resource id="rsc1" type="Dummy" class="ocf" provider="pacemaker">
+            <lrm_rsc_op id="rsc1_last_0" operation_key="rsc1_monitor_0" operation="monitor" crm-debug-origin="build_active_RAs" crm_feature_set="3.0.14" transition-key="9:1:7:2dc02a24-b145-46ac-ba2d-ee462fdab7ab" transition-magic="0:7;9:1:7:2dc02a24-b145-46ac-ba2d-ee462fdab7ab" on_node="remote2" call-id="39" rc-code="7" op-status="0" interval="0" last-run="1503334850" last-rc-change="1503334850" exec-time="11" queue-time="0" op-digest="f2317cad3d54cec5d7d7aa7d0bf35cf8" ra-version="1.0" op-force-restart=" fail_start_on  fake " op-restart-digest="f2317cad3d54cec5d7d7aa7d0bf35cf8" op-secure-params=" passwd " op-secure-digest="5de129d7fe42dbcfe537f2c63b1921b6"/>
+          </lrm_resource>
+        </lrm_resources>
+      </lrm>
+    </node_state>
+  </status>
+</cib>