commit be2e6b14f019e1e7f109fb5e7e4391edc42062cb
Author: Ken Gaillot <kgaillot@redhat.com>
Date:   Tue Dec 6 12:04:10 2016 -0600

    Log: various: fix spelling errors in log messages and comments

Index: pacemaker/BasicSanity.sh
===================================================================
--- pacemaker.orig/BasicSanity.sh
+++ pacemaker/BasicSanity.sh
@@ -31,7 +31,7 @@ function run_as_root() {
         $CMD
 
     elif [ -z $TRAVIS ]; then
-        # sudo doesn't work in builtbot, su doesn't work in travis
+        # sudo doesn't work in buildbot, su doesn't work in travis
         echo "Enter the root password..."
         su root -c "$CMD"
 
Index: pacemaker/cib/messages.c
===================================================================
--- pacemaker.orig/cib/messages.c
+++ pacemaker/cib/messages.c
@@ -544,7 +544,7 @@ sync_our_cib(xmlNode * request, gboolean
 
     /* remove the "all == FALSE" condition
      *
-     * sync_from was failing, the local client wasnt being notified
+     * sync_from was failing, the local client wasn't being notified
      *    because it didn't know it was a reply
      * setting this does not prevent the other nodes from applying it
      *    if all == TRUE
Index: pacemaker/fencing/commands.c
===================================================================
--- pacemaker.orig/fencing/commands.c
+++ pacemaker/fencing/commands.c
@@ -989,7 +989,7 @@ dynamic_list_search_cb(GPid pid, int rc,
 
 /*!
  * \internal
- * \brief Returns true if any key in first is not is second or second has a different value for key
+ * \brief Returns true if any key in first is not in second or second has a different value for key
  */
 static int
 device_params_diff(GHashTable *first, GHashTable *second) {
Index: pacemaker/include/crm/pengine/status.h
===================================================================
--- pacemaker.orig/include/crm/pengine/status.h
+++ pacemaker/include/crm/pengine/status.h
@@ -232,9 +232,11 @@ enum pe_action_flags {
     pe_action_clear = 0x00400,
     pe_action_dangle = 0x00800,
 
-    pe_action_requires_any = 0x01000, /* This action requires one or mre of its dependencies to be runnable
-                                       * We use this to clear the runnable flag before checking dependencies
-                                       */
+    /* This action requires one or more of its dependencies to be runnable.
+     * We use this to clear the runnable flag before checking dependencies.
+     */
+    pe_action_requires_any = 0x01000,
+
     pe_action_reschedule = 0x02000,
     pe_action_tracking = 0x04000,
 };
Index: pacemaker/lib/ais/plugin.c
===================================================================
--- pacemaker.orig/lib/ais/plugin.c
+++ pacemaker/lib/ais/plugin.c
@@ -663,7 +663,7 @@ pcmk_startup(struct corosync_api_v1 *ini
     if (use_mcp == FALSE) {
         pthread_create(&pcmk_wait_thread, NULL, pcmk_wait_dispatch, NULL);
         for (start_seq = 1; start_seq < max; start_seq++) {
-            /* dont start anything with start_seq < 1 */
+            /* don't start anything with start_seq < 1 */
             for (lpc = 0; lpc < max; lpc++) {
                 if (start_seq == pcmk_children[lpc].start_seq) {
                     spawn_child(&(pcmk_children[lpc]));
@@ -1108,7 +1108,7 @@ pcmk_shutdown(void)
     wait_active = FALSE;        /* stop the wait loop */
 
     for (; phase > 0; phase--) {
-        /* dont stop anything with start_seq < 1 */
+        /* don't stop anything with start_seq < 1 */
 
         for (lpc = max - 1; lpc >= 0; lpc--) {
             if (phase != pcmk_children[lpc].start_seq) {
Index: pacemaker/lib/cluster/cpg.c
===================================================================
--- pacemaker.orig/lib/cluster/cpg.c
+++ pacemaker/lib/cluster/cpg.c
@@ -637,7 +637,7 @@ send_cluster_text(int class, const char
     free(target);
 
 #if SUPPORT_PLUGIN
-    /* The plugin is the only time we dont use CPG messaging */
+    /* The plugin is the only time we don't use CPG messaging */
     if(get_cluster_type() == pcmk_cluster_classic_ais) {
         return send_plugin_text(class, iov);
     }
Index: pacemaker/lib/cluster/heartbeat.c
===================================================================
--- pacemaker.orig/lib/cluster/heartbeat.c
+++ pacemaker/lib/cluster/heartbeat.c
@@ -117,7 +117,7 @@ convert_ha_field(xmlNode * parent, void
 
             if (rc == BZ_OUTBUFF_FULL) {
                 size = size * 2;
-                /* dont try to allocate more memory than we have */
+                /* don't try to allocate more memory than we have */
                 if (size > 0) {
                     goto retry;
                 }
@@ -489,7 +489,7 @@ ha_msg_dispatch(ll_cluster_t * cluster_c
         if (cluster_conn->llc_ops->msgready(cluster_conn) == 0) {
             crm_trace("no message ready yet");
         }
-        /* invoke the callbacks but dont block.
+        /* invoke the callbacks but don't block.
          * cluster_conn->llc_ops->rcvmsg(cluster_conn, 0); */
         msg = cluster_conn->llc_ops->readmsg(cluster_conn, 0);
         if (msg) {
Index: pacemaker/lib/pengine/unpack.c
===================================================================
--- pacemaker.orig/lib/pengine/unpack.c
+++ pacemaker/lib/pengine/unpack.c
@@ -1493,7 +1493,7 @@ determine_online_status(xmlNode * node_s
     }
 
     if (online && this_node->details->shutdown) {
-        /* dont run resources here */
+        /* don't run resources here */
         this_node->fixed = TRUE;
         this_node->weight = -INFINITY;
     }
@@ -2380,14 +2380,14 @@ find_lrm_op(const char *resource, const
 }
 
 static void
-unpack_rsc_migration(resource_t *rsc, node_t *node, xmlNode *xml_op, pe_working_set_t * data_set) 
+unpack_rsc_migration(resource_t *rsc, node_t *node, xmlNode *xml_op, pe_working_set_t * data_set)
 {
-                
+
     /*
      * The normal sequence is (now): migrate_to(Src) -> migrate_from(Tgt) -> stop(Src)
      *
-     * So if a migrate_to is followed by a stop, then we dont need to care what
-     * happended on the target node
+     * So if a migrate_to is followed by a stop, then we don't need to care what
+     * happened on the target node
      *
      * Without the stop, we need to look for a successful migrate_from.
      * This would also imply we're no longer running on the source
@@ -3095,13 +3095,13 @@ unpack_rsc_op(resource_t * rsc, node_t *
     if (is_not_set(rsc->flags, pe_rsc_unique)) {
         parent = uber_parent(rsc);
     }
-    
+
     pe_rsc_trace(rsc, "Unpacking task %s/%s (call_id=%d, status=%d, rc=%d) on %s (role=%s)",
                  task_key, task, task_id, status, rc, node->details->uname, role2text(rsc->role));
 
     if (node->details->unclean) {
         pe_rsc_trace(rsc, "Node %s (where %s is running) is unclean."
-                     " Further action depends on the value of the stop's on-fail attribue",
+                     " Further action depends on the value of the stop's on-fail attribute",
                      node->details->uname, rsc->id);
     }
 
Index: pacemaker/lib/pengine/utils.c
===================================================================
--- pacemaker.orig/lib/pengine/utils.c
+++ pacemaker/lib/pengine/utils.c
@@ -516,7 +516,7 @@ custom_action(resource_t * rsc, char *ke
 #if 0
             /*
              * No point checking this
-             * - if we dont have quorum we can't stonith anyway
+             * - if we don't have quorum we can't stonith anyway
              */
         } else if (action->needs == rsc_req_stonith) {
             crm_trace("Action %s requires only stonith", action->uuid);
@@ -1413,7 +1413,7 @@ sort_op_by_callid(gconstpointer a, gcons
              *
              * if the UUID from the TE doesn't match then one better
              *   be a pending operation.
-             * pending operations dont survive between elections and joins
+             * pending operations don't survive between elections and joins
              *   because we query the LRM directly
              */
 
@@ -2087,7 +2087,7 @@ trigger_unfencing(
         return;
 
     } else if (rsc != NULL && is_not_set(rsc->flags, pe_rsc_fence_device)) {
-        /* Wasnt a stonith device */
+        /* Wasn't a stonith device */
         return;
 
     } else if(node
Index: pacemaker/mcp/pacemaker.c
===================================================================
--- pacemaker.orig/mcp/pacemaker.c
+++ pacemaker/mcp/pacemaker.c
@@ -384,7 +384,7 @@ pcmk_shutdown_worker(gpointer user_data)
     }
 
     for (; phase > 0; phase--) {
-        /* dont stop anything with start_seq < 1 */
+        /* Don't stop anything with start_seq < 1 */
 
         for (lpc = max - 1; lpc >= 0; lpc--) {
             pcmk_child_t *child = &(pcmk_children[lpc]);
@@ -782,7 +782,7 @@ init_children_processes(void)
 
     /* start any children that have not been detected */
     for (start_seq = 1; start_seq < max; start_seq++) {
-        /* dont start anything with start_seq < 1 */
+        /* don't start anything with start_seq < 1 */
         for (lpc = 0; lpc < max; lpc++) {
             if (pcmk_children[lpc].pid) {
                 /* we are already tracking it */
Index: pacemaker/pengine/graph.c
===================================================================
--- pacemaker.orig/pengine/graph.c
+++ pacemaker/pengine/graph.c
@@ -361,13 +361,13 @@ graph_update_action(action_t * first, ac
         && (flags & pe_action_optional) == 0) {
         processed = TRUE;
         crm_trace("%s implies %s printed", first->uuid, then->uuid);
-        update_action_flags(then, pe_action_print_always);      /* dont care about changed */
+        update_action_flags(then, pe_action_print_always);      /* don't care about changed */
     }
 
     if ((type & pe_order_implies_first_printed) && (flags & pe_action_optional) == 0) {
         processed = TRUE;
         crm_trace("%s implies %s printed", then->uuid, first->uuid);
-        update_action_flags(first, pe_action_print_always);     /* dont care about changed */
+        update_action_flags(first, pe_action_print_always);     /* don't care about changed */
     }
 
     if ((type & pe_order_implies_then
Index: pacemaker/pengine/native.c
===================================================================
--- pacemaker.orig/pengine/native.c
+++ pacemaker/pengine/native.c
@@ -2880,7 +2880,7 @@ native_start_constraints(resource_t * rs
 
         } else if (safe_str_eq(action->task, RSC_START)
                    && NULL == pe_hash_table_lookup(rsc->known_on, target->details->id)) {
-            /* if known == NULL, then we dont know if
+            /* if known == NULL, then we don't know if
              *   the resource is active on the node
              *   we're about to shoot
              *
@@ -2892,7 +2892,7 @@ native_start_constraints(resource_t * rs
              * it's analogous to waiting for all the probes
              *   for rscX to complete before starting rscX
              *
-             * the most likely explaination is that the
+             * the most likely explanation is that the
              *   DC died and took its status with it
              */
 
Index: pacemaker/pengine/regression.sh
===================================================================
--- pacemaker.orig/pengine/regression.sh
+++ pacemaker/pengine/regression.sh
@@ -138,7 +138,7 @@ do_test clone-require-all-7 "clone A and
 do_test clone-require-all-no-interleave-1 "C starts everywhere after A and B"
 do_test clone-require-all-no-interleave-2 "C starts on nodes 1, 2, and 4 with only one active instance of B"
 do_test clone-require-all-no-interleave-3 "C remains active when instance of B is stopped on one node and started on another."
-do_test one-or-more-unrunnnable-instances "Avoid dependencies on instances that wont ever be started"
+do_test one-or-more-unrunnnable-instances "Avoid dependencies on instances that won't ever be started"
 
 echo ""
 do_test order1 "Order start 1     "